#ifndef OptPrimaryGeneratorAction_h
#define OptPrimaryGeneratorAction_h 1

#include <G4VUserPrimaryGeneratorAction.hh>
#include <globals.hh>
#include <G4ThreeVector.hh>

#include "EsafMsgSource.hh"
#include "EsafConfigurable.hh"
class G4ParticleGun;
class G4Event;
class OptPrimaryGeneratorMessenger;
//class G4ThreeVector;

//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
class OptPrimaryGeneratorAction : public G4VUserPrimaryGeneratorAction, public EsafConfigurable, public EsafMsgSource
{
    public:
        OptPrimaryGeneratorAction(bool);
        virtual ~OptPrimaryGeneratorAction();

        void GeneratePrimaries(G4Event*);
        void Init();
        void FillCircle(G4Event*);
        void FillSphere(G4Event*);
        void OnePoint(G4Event* anEvent);
        void GenerateEnergy();
        void GenerateDirection();
    private:
        G4ParticleGun* particleGun;
        bool factive;
        double fThetaMin;
        double fThetaMax;
        double fPhiMin;
        double fPhiMax;
        double fTheta;
        double fPhi;
        double fEnergyMin;
        double fEnergyMax;
        double fEnergy;

        G4ThreeVector fDirection;
        EsafConfigClass(G4,PrimaryGeneratorAction)
};

//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......

#endif /*OptPrimaryGeneratorAction_h*/
