#ifndef OptSteppingAction_H
#define OptSteppingAction_H 1

#include <G4UserSteppingAction.hh>
#include <G4OpBoundaryProcess.hh>
#include "EsafMsgSource.hh"
#include <limits.h>

class G4Step;
class G4ProcessManager;
class G4ProcessVector;
class OptUserStackingAction;
class G4DisplacedSolid;
class OptSteppingAction : public G4UserSteppingAction, public EsafMsgSource
{
public:
    OptSteppingAction(OptUserStackingAction* stack);
    virtual ~OptSteppingAction();

    virtual void UserSteppingAction(const G4Step*);

private:
    G4ProcessManager*           fProcessManager;
    G4ProcessVector*            fProcessVector;
    G4OpBoundaryProcess*        fBoundary;
    G4OpBoundaryProcessStatus   theStatus;
    int                         fStatus;
    int                         fStatusKilled;
    OptUserStackingAction*      fStacking;

    int                         fStepCounter;
    int                         fMaxIterations;
    bool                        fTus;
    double                      r_cut;
    double                      r_wall;
    G4DisplacedSolid*           cover;

};

#endif
